//
//  ViewController.m
//  XYdiaoyongxiangjixiangce
//
//  Created by Xia on 16/8/24.
//  Copyright © 2016年 xiayong. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()<UIActionSheetDelegate,UIImagePickerControllerDelegate,UINavigationControllerDelegate>


@property(nonatomic,strong)UIImageView * imageV;

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    [self createImageV];
    
}

-(void)createImageV{

    self.imageV = [[UIImageView alloc]initWithFrame:CGRectMake(0, 100, 414, 300)];
    self.imageV.backgroundColor = [UIColor grayColor];
    
    self.imageV.userInteractionEnabled = YES;
    
    [self.imageV addGestureRecognizer:[[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(addActionTap:)]];
   
    
    
    [self.view addSubview:self.imageV];
}

-(void)addActionTap:(UITapGestureRecognizer *)tap{

    NSLog(@"走了走了");
 
    [self chooseImage];

}

-(void)chooseImage{

    UIActionSheet * sheet;
   //判断是否支持相机
    
    if ([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera]) {
        
        sheet = [[UIActionSheet alloc]initWithTitle:@"更换头像" delegate:self cancelButtonTitle:nil destructiveButtonTitle:@"拍照" otherButtonTitles:@"从相册中选择",@"取消",nil];
        
        
    }else{
    
        sheet = [[UIActionSheet alloc]initWithTitle:@"选择" delegate:self cancelButtonTitle:nil destructiveButtonTitle:@"取消" otherButtonTitles:@"从相册中选择", nil];
    
    
    }
    
    sheet.tag = 255;
    
    [sheet showInView:self.view];



}

#pragma mark ----------实现 actionSheet delegate 事件------------


-(void)actionSheet:(UIActionSheet *)actionSheet clickedButtonAtIndex:(NSInteger)buttonIndex{
    if (actionSheet.tag == 255) {
        
        NSUInteger sourceType = 0;
        
        //判断是否支持相机
        if ([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera]) {
            
            switch (buttonIndex) {
                case 2:
                    //取消
                    return;
                    
                case 0:{
                    //相机
                    sourceType = UIImagePickerControllerSourceTypeCamera;
                    
                    break;}
                case 1:{
                 //相册
                    sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
                    break;
                
                }
                    
                default:
                    break;
            }
            
            
            
            
        }else{
        
            if (buttonIndex == 0) {
                [self.navigationController popViewControllerAnimated:YES];
            }else{
            
                sourceType = UIImagePickerControllerSourceTypeSavedPhotosAlbum;
            
            }
        
        
        }
            
        //跳转到相机或相册界面
        UIImagePickerController * imagePickerController = [[UIImagePickerController alloc]init];
        
        imagePickerController.delegate = self;
        
        imagePickerController.allowsEditing = YES;
        
        
        imagePickerController.sourceType = sourceType;
        
        [self presentViewController:imagePickerController animated:YES completion:^{
            
        }];
        
        
    }
 







}


#pragma mark--image picker 的代理方法


-(void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary<NSString *,id> *)info{

    [picker dismissViewControllerAnimated:YES completion:nil];


    UIImage * image = [info objectForKey:UIImagePickerControllerEditedImage];
    

    self.imageV.image = image;
    
    [self saveImage:image withName:@"wodetu"];

}


#pragma mark-保存图片至沙盒

-(void)saveImage:(UIImage *)currentImage withName:(NSString *)imageName{

//NSData * UIImageJPEGRepresentation (UIImage * image,CGFloat compression)
//高保真压缩图片，此方法可以将图片压缩，但图片质量基本保存不变，第二个参数即图片质量参数
   

    NSData * imageData = UIImageJPEGRepresentation(currentImage, 0.5);
    //获取沙盒目录
    NSString * fullPath = [[NSHomeDirectory() stringByAppendingPathComponent:@"Documents"]stringByAppendingPathComponent:imageName];
    
    NSLog(@"################%@",fullPath);
    
    
    //将图片写入文件
    
    [imageData writeToFile:fullPath atomically:NO];
 
}

-(void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event{

   








}







- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
